var REFApp = REFApp || {
    /**
     * Fetches reference matches using an AJAX call
     *
     * @param {itemId} The id of the item
     * @param {mode}   The mode of the call (either "ref" or "fulltext"
     * 
     */
    fetchReferenceMatches: function(itemId, mode) {

        var hiddenContext = $("#hiddenContext").text();
        var matchesUrl = hiddenContext + "/references/matchedRefsForItem.action?itemId=" + itemId;
        
        $.getJSON(matchesUrl, function(response) {
            var aRef,
                consoleMsg,
                doiLink,
                loop,
                match,
                matches,
                mLoop,
                mLen,
                newLinkHtml,
                $target,
                tmp = "";
            if (response !== null) {
                // if (AIPApp.consoleOK) {console.info("fetchReferenceMatches() AJAX response received...\n\n" + JSON.stringify(response, null, ' ') + "\n\n");}
                mLen = response.referenceItems.length;
                for (loop = 0; loop < mLen; loop++) {
                    aRef = response.referenceItems[loop];
                    tmp = mode === "ref" ? "#ref-" + aRef.id : "#" + aRef.id;
                    $target = $(tmp);
                    doiLink = $target.find("a.externallink").attr("href");
                    // Remove leading host (http://dx.doi.org/)...
                    // consoleMsg = "fetchReferenceMatches() " + (doiLink ? "DOI: " + doiLink.substr(18) : "NO DOI");
                    // if (AIPApp.consoleOK) {console.info(consoleMsg);}
                    if ($target.size() > 0) {
                        newLinkHtml = "<span class='refmatch'>";
                        matches = aRef.matches.length;
                        for (mLoop = 0; mLoop < matches; mLoop++) {
                            match = aRef.matches[mLoop];
                            if (match.thirdParty.name !== "CrossRef matcher") {
                                newLinkHtml += " [ <a href='" + match.linkUri + 
                                               "' class='externallink' rel='external' title='Link to external reference'>" + match.thirdParty.name +  
                                               "</a>]";
                            // } else {
                                // TODO: Insert DOI if there is a match and existing ref does not have one...
                                // if (!doiLink) {
                                    // if (AIPApp.consoleOK) {console.info("fetchReferenceMatches() Insert DOI match here...");}
                                // }
                            }
                        }
                        newLinkHtml += "</span>";
                        $target.append(newLinkHtml);
                    }
                }
            } 
        });

    }
};

$(document).ready(function() {
    var itemWebId = $("#itemWebIdForRefs").text();
    if (itemWebId) {
        REFApp.fetchReferenceMatches(itemWebId, "ref");
    }
});
